/*
 *    Copyright  1996, 1997, 1998, 1999, 2000 by Remco Treffkorn
 *    Distributed under the terms of the Q Public License. Please see
 *    the included file LICENSE.
 */
#include "config.h"
#include <stdio.h>
#include <ctype.h>
#include <assert.h>
#include "debug.h"


/*
 *    None of these implements the behaviour of the man page.
 *    The original strsep() does not get it right either.
 *    Three cases have to be handled:
 *	1. delim found, strlen(token) > 0
 *	2. delim found, strlen(token) == 0
 *      3. delim not found
 */

char *mystrsep( char **stringp, char *delim)
{
  char *begin, *end;

  begin = *stringp + strspn (*stringp, delim);
  end = *stringp + strcspn (*stringp, delim);

  if (end == *stringp)
    return NULL;

  if (*end != '\0')
    *end++ = '\0';
  *stringp = end;

  return begin;
}

char *mystrsep2( char **stringp, char *delim)
{
  char *begin, *end;

  begin = *stringp + strspn (*stringp, delim);
  end = *stringp + strcspn (*stringp, delim);

  if (end == *stringp)
    begin = NULL;

  if (*end != '\0')
    *end++ = '\0';
  *stringp = end;

  return begin;
}

void strtolower(char *p)
{
    while( *p ) {
	if (isupper(*p)) *p=tolower(*p);
	p++;
   }
} 

void strtoupper(char *p)
{
    while( *p ) {
	if (islower(*p)) *p=toupper(*p);
	p++;
   }
} 

#ifdef DO_ALIGN
inline long my_align( void *p )
{
    long l;
    char *q = (char *) &l;

    *q++ = *(char *)p++;
    *q++ = *(char *)p++;
    *q++ = *(char *)p++;
    *q++ = *(char *)p++;

    return l;
}
#endif
